#!/usr/bin/perl

# $Id: new_policy.pl,v 1.33 1997/09/16 22:40:35 frances Exp $

# Globals

  push(@INC, "/usr/local/www/cgi-bin");
  require 'qos-lib.pl';

  &ReadInput(*INPUT);
  &ParseData(*GLOBAL, $INPUT);
  &set_var;

  &display_help;

  if ($duplicate != 0) {
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	print "You have specified a duplicate policy name.<br>\n";
	print "<img src=\"/images/config/redbar.gif\">\n";
	print "<br>\n";
        &disp_current_table;
  }
  elsif ($space_name) {
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	print "No space character allowed in a policy name.<br>\n";
	print "<img src=\"/images/config/redbar.gif\">\n";
	print "<br>\n";
        &disp_current_table;
  }
  elsif ($confirm eq "OK" && $newtable eq "") {
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	print "You did not specify a new policy name.\n";
	print "<img src=\"/images/config/redbar.gif\">\n";
	print "<br>\n";
        &disp_current_table;
  }
  else {
    &disp_current_table;
    if ($confirm eq "OK" && $newtable && !$duplicate) {
	if ($action eq "Create") {
	  &disp_new;
	}
    }
    elsif ($action eq "Create" || $action eq "Copy") {
	&disp_new;
    }
    elsif ((!$mastertable && !$selectpolicy && $action eq "") ||
		!$PolicyListSize) {

	print "<hr>\n";
        print "<center>\n";
        print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/new_policy.pl\">\n";
        print "<br><h4>\n";
        print "There is no service policy defined.  Do you wish to create one now?</h4><br>\n";
        print "<br>\n";
        print "<INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Create\">\n";
        print "</FORM>\n\n";
    }
  }

#print "End: ", &ctime(time), "<br>\n";
  &PrintHeadToe("TRAILER", 
    "", 
    "/voy.guide/Qos_tasks.fm.html", 
    "/cgi-bin/html_page?TEMPLATE=main",
    "/cgi-bin/new_policy.pl?IHelp=$nhelp",
    "/cgi-bin/html_page?TEMPLATE=main");

################################################

sub display_help {
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
	print "<font -= 4><br>";
        open(FD, "/usr/local/config/help/qos.editRule.html");
        while (<FD>) {
            print;
        }
        close(FD);
	print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub disp_new {
    if ($newtable eq "") {
    print "<hr>\n";
	print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/new_policy.pl\">\n\n";
	print "<center>\n";
	print "<h4>New policy name: <INPUT TYPE=\"text\" NAME=\"NewTable\" SIZE=20>\n";
	print "<br><br>\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"Confirm\" VALUE=\"OK\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"Action\" VALUE=\"$action\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"TableSelect\" VALUE=\"$tableselect\">\n";
	print "<INPUT TYPE=\"image\" SRC=\"/images/config/applybutton.gif\" BORDER=0>\n";
	print "</FORM></center>\n\n";
    }
    else {
        print "<hr>\n";
	$mastertable = $newtable;
	print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/change_rule.pl\">\n";
	print "<center>\n";
	print "<b>New policy <i>$newtable</i> is created.</b><br><br>\n";
	print "You must create rule(s) for this policy in order for it to take effect.<br>\n";
	print "Press \"Create Rule\" to create new rule(s) for this policy.<br>\n";
	print "<br>\n";
	print "<h5><INPUT TYPE=\"hidden\" NAME=\"FlowEdit\" VALUE=\"Create\"></h5>\n";
	print "<h5><INPUT TYPE=\"submit\" NAME=\"Junk\" VALUE=\"Create Rule\"></h5>\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"CurrentTable\" VALUE=\"$mastertable\">\n";
	print "</FORM></center>\n";
    }
}

sub disp_copy_from {
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/new_policy.pl\">\n\n";
    print "<center><table><tr>\n";
    print "<td><b>Policy <i>$newtable</i>:</b>\n";
    print "<td>\n";
    &disp_rules;
    print "</tr></table>\n";
    print "</FORM>\n\n";
}

sub disp_current_table {
#    print "mastertable=$mastertable. selectpolicy=$selectpolicy, currorder=$currorder.<br>\n";
# print "disp_current_table: PolicyListSize=$PolicyListSize.<br>\n";

    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/new_policy.pl\">\n";
    print "<center>";
    if ($PolicyListSize > 0) {
      print "<table>\n";
      print "<tr>\n";
      print "<td align=right><b>Current QoS policies: </b>";
      print "<td align=left>\n";
      &disp_policy_list;
      print "</tr>\n";
      print "</table>\n";
    }

    print "<table><tr>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Select\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Delete\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Create\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Copy\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Use As Default\"></h5>\n";
    print "</tr></table>\n\n";
    print "</FORM>\n\n";
}

sub edit_policy {
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/new_policy.pl\">\n";
    print "<center><table><tr>\n";
    print "<td align=right><b>Rules for policy <i>$mastertable</i>:</b>\n";
    print "<td align=left>\n";
    &disp_rules;
    print "</tr></table>\n\n";

    print "<INPUT TYPE=\"hidden\" NAME=\"Action\" VALUE=\"$action\">\n";
    print "</FORM></center>\n\n";
}

sub set_var {
    $action = $GLOBAL{'Action'};
    $newtable = $GLOBAL{'NewTable'};
    $tableselect = $GLOBAL{'TableSelect'};

    $confirm = $GLOBAL{'Confirm'};
    $ihelp = $GLOBAL{'IHelp'};
    if (!$ihelp || $ihelp eq "off") {
	$ihelp = "off";
	$nhelp = "on";
    }
    elsif ($ihelp eq "on") {
	$nhelp = "off";
    }

    if ($action eq "Select") {
	$o = &GetIndexedValue("machine:$mname:policy:qostable:control:edit:name", 6);
	&PrintHeadToe("GOTO", "/cgi-bin/qos.pl");
	&PrintHeadToe("TRAILER", "", "", "", "");
    }
    else {
	&PrintHeadToe("HEADER", 
	    "QoS Policy Configuration", 
	    "/voy.guide/Qos_tasks.fm.html", 
	    "/cgi-bin/html_page?TEMPLATE=main",
	    "/cgi-bin/new_policy.pl?IHelp=$nhelp",
	    "/cgi-bin/html_page?TEMPLATE=main");
    }
#print "Start: ", &ctime(time), "<br>\n";

    &get_data;
    &get_policies;
    &get_default_policy;
    &GetCurrentPolicy;

#print "mastertable=$mastertable, selectpolicy=$selectpolicy.<br>\n";
#print "confirm=$confirm, action=$action, newtable=$newtable.<br>\n";

    if ($action eq "Use As Default") {
	$oo = 0;
	@interfaces = ();
	@interfaces = grep(/machine:$mname:interface:/, @a);
	foreach $item (@interfaces) {
	    ($ii, $d) = split(/ /, $item); 
	    ($i, $d) = split(/\n/, $ii); 
	    $o = &GetValue("$i:rate");
	    if ($o eq "t") {
		$oo = 1;
	    }
	}

	if ($oo) {
	    print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	    print "You cannot enable both QoS and hardware Rate Shaping at the same time.  Please disable the hardware Rate Shaping on the ATM interface page before proceeding with this configuration.<br>\n";
	    print "<img src=\"/images/config/redbar.gif\"><br>\n";
	    $o = &GetValue("machine:$mname:policy:qostable:control:default:name");
	    if ($o) {
		$mastertable = $tableselect;
		$selectpolicy = "";
		&get_default_policy;
	    }
	}
	else {
	  $o = &GetValue("machine:$mname:swrate");
	  if ($o eq "t") {
	    print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	    print "You cannot enable both QoS and software Rate Shaping at the same time.  Please disable the software Rate Shaping before proceeding with this configuration.<br>\n";
	    print "<img src=\"/images/config/redbar.gif\"><br>\n";
	    $o = &GetValue("machine:$mname:policy:qostable:control:default:name");
	    if ($o) {
		$mastertable = $tableselect;
		$selectpolicy = "";
		&get_default_policy;
	    }
	  }
	  else {
	      $mastertable = $tableselect;
	      $selectpolicy = "";
	      &update_conf("machine:$mname:policy:qostable:control:default:name $mastertable", 0);
	      &get_default_policy;
	  }
	}
    }
    elsif ($action eq "Select") {
	$mastertable = $tableselect;
	$selectpolicy = "";
	&update_conf("machine:$mname:policy:qostable:control:edit:name $mastertable\n", 0);
    }

    # if we're creating new table, then let's see if we need to fill it up
    if (($confirm eq "OK" && $newtable eq "") || (!$confirm && !$newtable)) {
	$duplicate = 0;
    }
    else {
	$exist = &CheckDuplicate("^machine:$mname:policy:qostable:$newtable");
	$space_name = &CheckSpace($newtable);
	if ($exist != 0) {
	    $duplicate = 1;
	}
	elsif (!$space_name) {
#	  &get_data;
	  if ($tableselect eq "" && $PolicyListSize == 1) {
		$mastertable = $tableselect = $POLICYLIST[0];
		($mastertable, $m) = split(' ', $mastertable);
	  }
	  else {
		$mastertable = $tableselect;
		($mastertable, $m) = split(' ', $mastertable);
	  }

	  if ($action eq "Copy") {
	    @oldlines = grep(/^machine:$mname:policy:qostable:$mastertable/, @a);
	    $newlines="machine:$mname:policy:qostable:control:edit:name $newtable\nmachine:$mname:policy:qostable:$newtable t\n";

	    foreach $line (@oldlines) {
	      $newline = $line;
	      $newline =~s/$mastertable/$newtable/g;
	      $newlines=$newlines.$newline;
	    }

	    @aa = grep(/^machine:$mname:policy:class:/, @a);
	    @oldlines = ();
	    @oldlines = grep(/$mastertable/, @aa);

	    foreach $line (@oldlines) {
	      $newline = $line;
	      $newline =~s/$mastertable/$newtable/g;
	      $newlines=$newlines.$newline;
	    }

	    &update_conf($newlines, 1);

	    $mastertable = $newtable;
	    &get_data;
	    &get_policies;
	    &get_rules_from_current_policy;
	  }
	  elsif ($action eq "Create") {
	    &update_conf("machine:$mname:policy:qostable:control:edit:name $newtable\nmachine:$mname:policy:qostable:$newtable t\n", 0);

	    $mastertable = $newtable;
	    &get_data;
	    &get_policies;
	    &get_rules_from_current_policy;
	  }
	}
    }

    @F = (); 
    if ($action eq "Delete") {
	$F="\n\nmachine:$mname:policy:qostable:$mastertable\n";

#	$default_policy = &GetIndexedValue("machine:$mname:policy:qostable:control:default:name", 6);
	if ($default_policy eq $mastertable) {
	    $new="machine:$mname:policy:qostable:control:default:name\n";
	    $F=$F.$new;
	}

	&get_rules_from_current_policy;

	foreach $r (@PLIST) {
	  $new="machine:$mname:policy:qostable:$mastertable:$r\nmachine:$mname:policy:qostable:$mastertable:$r:class\nmachine:$mname:policy:qostable:$mastertable:$r:filter\nmachine:$mname:policy:qostable:$mastertable:$r:name\nmachine:$mname:policy:qostable:$mastertable:$r:priority\nmachine:$mname:policy:qostable:$mastertable:$r:swt\n";
	  $F=$F.$new;
	}

#print "deleting policy with $F.<br>\n";
	&update_conf($F, 1);
	if ($mastertable eq $tableselect) {
	    $mastertable = "";
	}
        &get_data;
	&get_policies;

    }

    if ($selectpolicy eq "") {
       $selectpolicy = $PNAMELIST[0];
       $policy_order = $PLIST[0];
#       print "selectpolicy=$selectpolicy, policy_order=$policy_order<br>";
    }
}

