if (!defined &_CURSES_H_) {
    eval 'sub _CURSES_H_ {1;}';
    require 'sys/types.ph';
    require 'sys/cdefs.ph';
    require 'stdio.ph';
    if (!defined &_BSD_VA_LIST_) {
	eval 'sub _BSD_VA_LIST_ {char *;}';
    }
    if (!defined &_CURSES_PRIVATE) {
	require 'termios.ph';
	require 'sys/ioctl.ph';
	require 'sys/ioctl_compat.ph';
	eval 'sub bool {char;}';
	eval 'sub reg {defined &register && &register;}';
	if (!defined &TRUE) {
	    eval 'sub TRUE {(1);}';
	}
	if (!defined &FALSE) {
	    eval 'sub FALSE {(0);}';
	}
	eval 'sub _puts {
	    local($s) = @_;
	    eval " &tputs($s, 0, defined &__cputchar && &__cputchar)";
	}';
	eval 'sub baudrate {
	    eval "( &cfgetospeed(&defined &__baset && &__baset))";
	}';
	eval 'sub crmode {
	    eval " &cbreak()";
	}';
	eval 'sub erasechar {
	    eval "(defined &__baset && &__baset.defined &c_cc && &c_cc[defined &VERASE && &VERASE])";
	}';
	eval 'sub killchar {
	    eval "(defined &__baset && &__baset.defined &c_cc && &c_cc[defined &VKILL && &VKILL])";
	}';
	eval 'sub nocrmode {
	    eval " &nocbreak()";
	}';
	eval 'sub _curx {defined &curx && &curx;}';
	eval 'sub _cury {defined &cury && &cury;}';
	eval 'sub _begx {defined &begx && &begx;}';
	eval 'sub _begy {defined &begy && &begy;}';
	eval 'sub _maxx {defined &maxx && &maxx;}';
	eval 'sub _maxy {defined &maxy && &maxy;}';
	eval 'sub _tty {defined &__baset && &__baset;}';
    }
    eval 'sub unctrl {
        local($c) = @_;
        eval "defined &__unctrl && &__unctrl[($c) & 0xff]";
    }';
    eval 'sub unctrllen {
        local($ch) = @_;
        eval "defined &__unctrllen && &__unctrllen[($ch) & 0xff]";
    }';
    eval 'sub __STANDOUT {0x01;}';
    eval 'sub __LDATASIZE {($sizeof{defined &__LDATA && &__LDATA});}';
    eval 'sub __ISDIRTY {0x01;}';
    eval 'sub __ISPASTEOL {0x02;}';
    eval 'sub __FORCEPAINT {0x04;}';
    eval 'sub __ENDLINE {0x001;}';
    eval 'sub __FLUSH {0x002;}';
    eval 'sub __FULLWIN {0x004;}';
    eval 'sub __IDLINE {0x008;}';
    eval 'sub __SCROLLWIN {0x010;}';
    eval 'sub __SCROLLOK {0x020;}';
    eval 'sub __CLEAROK {0x040;}';
    eval 'sub __WSTANDOUT {0x080;}';
    eval 'sub __LEAVEOK {0x100;}';
    eval 'sub __FULLLINE {0x200;}';
    eval 'sub ERR {(0);}';
    eval 'sub OK {(1);}';
    eval 'sub addbytes {
        local($s, $n) = @_;
        eval " &__waddbytes(defined &stdscr && &stdscr, $s, $n, 0)";
    }';
    eval 'sub addch {
        local($ch) = @_;
        eval " &waddch(defined &stdscr && &stdscr, $ch)";
    }';
    eval 'sub addnstr {
        local($s, $n) = @_;
        eval " &waddnstr(defined &stdscr && &stdscr, $s, $n)";
    }';
    eval 'sub addstr {
        local($s) = @_;
        eval " &__waddbytes(defined &stdscr && &stdscr, $s,  &strlen($s), 0)";
    }';
    eval 'sub clear {
        eval " &wclear(defined &stdscr && &stdscr)";
    }';
    eval 'sub clrtobot {
        eval " &wclrtobot(defined &stdscr && &stdscr)";
    }';
    eval 'sub clrtoeol {
        eval " &wclrtoeol(defined &stdscr && &stdscr)";
    }';
    eval 'sub delch {
        eval " &wdelch(defined &stdscr && &stdscr)";
    }';
    eval 'sub deleteln {
        eval " &wdeleteln(defined &stdscr && &stdscr)";
    }';
    eval 'sub erase {
        eval " &werase(defined &stdscr && &stdscr)";
    }';
    eval 'sub getch {
        eval " &wgetch(defined &stdscr && &stdscr)";
    }';
    eval 'sub getstr {
        local($s) = @_;
        eval " &wgetstr(defined &stdscr && &stdscr, $s)";
    }';
    eval 'sub inch {
        eval " &winch(defined &stdscr && &stdscr)";
    }';
    eval 'sub insch {
        local($ch) = @_;
        eval " &winsch(defined &stdscr && &stdscr, $ch)";
    }';
    eval 'sub insertln {
        eval " &winsertln(defined &stdscr && &stdscr)";
    }';
    eval 'sub move {
        local($y, $x) = @_;
        eval " &wmove(defined &stdscr && &stdscr, $y, $x)";
    }';
    eval 'sub refresh {
        eval " &wrefresh(defined &stdscr && &stdscr)";
    }';
    eval 'sub standend {
        eval " &wstandend(defined &stdscr && &stdscr)";
    }';
    eval 'sub standout {
        eval " &wstandout(defined &stdscr && &stdscr)";
    }';
    eval 'sub waddbytes {
        local($w, $s, $n) = @_;
        eval " &__waddbytes($w, $s, $n, 0)";
    }';
    eval 'sub waddstr {
        local($w, $s) = @_;
        eval " &__waddbytes($w, $s,  &strlen($s), 0)";
    }';
    eval 'sub mvaddbytes {
        local($y, $x, $s, $n) = @_;
        eval " &mvwaddbytes(defined &stdscr && &stdscr, $y, $x, $s, $n)";
    }';
    eval 'sub mvaddch {
        local($y, $x, $ch) = @_;
        eval " &mvwaddch(defined &stdscr && &stdscr, $y, $x, $ch)";
    }';
    eval 'sub mvaddnstr {
        local($y, $x, $s, $n) = @_;
        eval " &mvwaddnstr(defined &stdscr && &stdscr, $y, $x, $s, $n)";
    }';
    eval 'sub mvaddstr {
        local($y, $x, $s) = @_;
        eval " &mvwaddstr(defined &stdscr && &stdscr, $y, $x, $s)";
    }';
    eval 'sub mvdelch {
        local($y, $x) = @_;
        eval " &mvwdelch(defined &stdscr && &stdscr, $y, $x)";
    }';
    eval 'sub mvgetch {
        local($y, $x) = @_;
        eval " &mvwgetch(defined &stdscr && &stdscr, $y, $x)";
    }';
    eval 'sub mvgetstr {
        local($y, $x, $s) = @_;
        eval " &mvwgetstr(defined &stdscr && &stdscr, $y, $x, $s)";
    }';
    eval 'sub mvinch {
        local($y, $x) = @_;
        eval " &mvwinch(defined &stdscr && &stdscr, $y, $x)";
    }';
    eval 'sub mvinsch {
        local($y, $x, $c) = @_;
        eval " &mvwinsch(defined &stdscr && &stdscr, $y, $x, $c)";
    }';
    eval 'sub mvwaddbytes {
        local($w, $y, $x, $s, $n) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &__waddbytes($w, $s, $n, 0))";
    }';
    eval 'sub mvwaddch {
        local($w, $y, $x, $ch) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddch($w, $ch))";
    }';
    eval 'sub mvwaddnstr {
        local($w, $y, $x, $s, $n) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddnstr($w, $s, $n))";
    }';
    eval 'sub mvwaddstr {
        local($w, $y, $x, $s) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &__waddbytes($w, $s,  &strlen($s), 0))";
    }';
    eval 'sub mvwdelch {
        local($w, $y, $x) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &wdelch($w))";
    }';
    eval 'sub mvwgetch {
        local($w, $y, $x) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &wgetch($w))";
    }';
    eval 'sub mvwgetstr {
        local($w, $y, $x, $s) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &wgetstr($w, $s))";
    }';
    eval 'sub mvwinch {
        local($w, $y, $x) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &winch($w))";
    }';
    eval 'sub mvwinsch {
        local($w, $y, $x, $c) = @_;
        eval "( &wmove($w, $y, $x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &winsch($w, $c))";
    }';
    eval 'sub clearok {
        local($w, $bf) = @_;
        eval "(($bf) ? (($w)->defined &flags && &flags |= defined &__CLEAROK && &__CLEAROK) : (($w)->defined &flags && &flags &= ~defined &__CLEAROK && &__CLEAROK))";
    }';
    eval 'sub flushok {
        local($w, $bf) = @_;
        eval "(($bf) ? (($w)->defined &flags && &flags |= defined &__FLUSH && &__FLUSH) : (($w)->defined &flags && &flags &= ~defined &__FLUSH && &__FLUSH))";
    }';
    eval 'sub getyx {
        local($w, $y, $x) = @_;
        eval "($y) = ($w)->defined &cury && &cury, ($x) = ($w)->defined &curx && &curx";
    }';
    eval 'sub leaveok {
        local($w, $bf) = @_;
        eval "(($bf) ? (($w)->defined &flags && &flags |= defined &__LEAVEOK && &__LEAVEOK) : (($w)->defined &flags && &flags &= ~defined &__LEAVEOK && &__LEAVEOK))";
    }';
    eval 'sub scrollok {
        local($w, $bf) = @_;
        eval "(($bf) ? (($w)->defined &flags && &flags |= defined &__SCROLLOK && &__SCROLLOK) : (($w)->defined &flags && &flags &= ~defined &__SCROLLOK && &__SCROLLOK))";
    }';
    eval 'sub winch {
        local($w) = @_;
        eval "(($w)->defined &lines && &lines[($w)->defined &cury && &cury]->defined &line && &line[($w)->defined &curx && &curx].defined &ch && &ch & 0377)";
    }';
    if (defined &_CURSES_PRIVATE) {
	eval 'sub min {
	    local($a,$b) = @_;
	    eval "($a < $b ? $a : $b)";
	}';
	eval 'sub max {
	    local($a,$b) = @_;
	    eval "($a > $b ? $a : $b)";
	}';
    }
    else {
    }
}
1;
