if (!defined &_FLOATINGPOINT_H_) {
    eval 'sub _FLOATINGPOINT_H_ {1;}';
    require 'sys/cdefs.ph';
    require 'machine/ieeefp.ph';
    if (defined &__GNUC__) {
	eval 'sub __fldenv {
	    local($addr) = @_;
	    eval "defined &__asm && &__asm  &__volatile(\\"fldenv %0\\" : : \\"m\\" (*($addr)))";
	}';
	eval 'sub __fnstenv {
	    local($addr) = @_;
	    eval "defined &__asm && &__asm  &__volatile(\\"fnstenv %0\\" : \\"=m\\" (*($addr)))";
	}';
	eval 'sub __fnstcw {
	    local($addr) = @_;
	    eval "defined &__asm && &__asm  &__volatile(\\"fnstcw %0\\" : \\"=m\\" (*($addr)))";
	}';
	eval 'sub __fnstsw {
	    local($addr) = @_;
	    eval "defined &__asm && &__asm  &__volatile(\\"fnstsw %0\\" : \\"=m\\" (*($addr)))";
	}';
    }
    eval 'sub fpgetround {
        eval "(( &__fpgetreg(defined &FP_RND_REG && &FP_RND_REG) & defined &FP_RND_FLD && &FP_RND_FLD) >> defined &FP_RND_OFF && &FP_RND_OFF)";
    }';
    eval 'sub fpsetround {
        local($m) = @_;
        eval " &__fpsetreg(($m), defined &FP_RND_REG && &FP_RND_REG, defined &FP_RND_FLD && &FP_RND_FLD, defined &FP_RND_OFF && &FP_RND_OFF)";
    }';
    eval 'sub fpgetprec {
        eval "(( &__fpgetreg(defined &FP_PRC_REG && &FP_PRC_REG) & defined &FP_PRC_FLD && &FP_PRC_FLD) >> defined &FP_PRC_OFF && &FP_PRC_OFF)";
    }';
    eval 'sub fpsetprec {
        local($m) = @_;
        eval " &__fpsetreg(($m), defined &FP_PRC_REG && &FP_PRC_REG, defined &FP_PRC_FLD && &FP_PRC_FLD, defined &FP_PRC_OFF && &FP_PRC_OFF)";
    }';
    eval 'sub fpgetmask {
        eval "((~ &__fpgetreg(defined &FP_MSKS_REG && &FP_MSKS_REG) & defined &FP_MSKS_FLD && &FP_MSKS_FLD) >> defined &FP_MSKS_OFF && &FP_MSKS_OFF)";
    }';
    eval 'sub fpsetmask {
        local($m) = @_;
        eval " &__fpsetreg(~($m), defined &FP_MSKS_REG && &FP_MSKS_REG, defined &FP_MSKS_FLD && &FP_MSKS_FLD, defined &FP_MSKS_OFF && &FP_MSKS_OFF)";
    }';
    eval 'sub fpgetsticky {
        eval "(( &__fpgetreg(defined &FP_STKY_REG && &FP_STKY_REG) & defined &FP_STKY_FLD && &FP_STKY_FLD) >> defined &FP_STKY_OFF && &FP_STKY_OFF)";
    }';
    eval 'sub fpresetsticky {
        local($m) = @_;
        eval " &__fpsetreg(0, defined &FP_STKY_REG && &FP_STKY_REG, ($m), defined &FP_STKY_OFF && &FP_STKY_OFF)";
    }';
    eval 'sub fpsetsticky {
        local($m) = @_;
        eval " &fpresetsticky($m)";
    }';
}
1;
