if (!defined &_SYS_MALLOC_H_) {
    eval 'sub _SYS_MALLOC_H_ {1;}';
    eval 'sub M_WAITOK {0x0000;}';
    eval 'sub M_NOWAIT {0x0001;}';
    eval 'sub M_KERNEL {0x0002;}';
    eval 'sub M_FREE {0;}';
    eval 'sub M_MBUF {1;}';
    eval 'sub M_DEVBUF {2;}';
    eval 'sub M_SOCKET {3;}';
    eval 'sub M_PCB {4;}';
    eval 'sub M_RTABLE {5;}';
    eval 'sub M_HTABLE {6;}';
    eval 'sub M_FTABLE {7;}';
    eval 'sub M_ZOMBIE {8;}';
    eval 'sub M_IFADDR {9;}';
    eval 'sub M_SOOPTS {10;}';
    eval 'sub M_SONAME {11;}';
    eval 'sub M_NAMEI {12;}';
    eval 'sub M_GPROF {13;}';
    eval 'sub M_IOCTLOPS {14;}';
    eval 'sub M_MAPMEM {15;}';
    eval 'sub M_CRED {16;}';
    eval 'sub M_PGRP {17;}';
    eval 'sub M_SESSION {18;}';
    eval 'sub M_IOV {19;}';
    eval 'sub M_MOUNT {20;}';
    eval 'sub M_FHANDLE {21;}';
    eval 'sub M_NFSREQ {22;}';
    eval 'sub M_NFSMNT {23;}';
    eval 'sub M_NFSNODE {24;}';
    eval 'sub M_VNODE {25;}';
    eval 'sub M_CACHE {26;}';
    eval 'sub M_DQUOT {27;}';
    eval 'sub M_UFSMNT {28;}';
    eval 'sub M_SHM {29;}';
    eval 'sub M_VMMAP {30;}';
    eval 'sub M_VMMAPENT {31;}';
    eval 'sub M_VMOBJ {32;}';
    eval 'sub M_VMOBJHASH {33;}';
    eval 'sub M_VMPMAP {34;}';
    eval 'sub M_VMPVENT {35;}';
    eval 'sub M_VMPAGER {36;}';
    eval 'sub M_VMPGDATA {37;}';
    eval 'sub M_FILE {38;}';
    eval 'sub M_FILEDESC {39;}';
    eval 'sub M_LOCKF {40;}';
    eval 'sub M_PROC {41;}';
    eval 'sub M_SUBPROC {42;}';
    eval 'sub M_SEGMENT {43;}';
    eval 'sub M_LFSNODE {44;}';
    eval 'sub M_FFSNODE {45;}';
    eval 'sub M_MFSNODE {46;}';
    eval 'sub M_NQLEASE {47;}';
    eval 'sub M_NQMHOST {48;}';
    eval 'sub M_NETADDR {49;}';
    eval 'sub M_NFSSVC {50;}';
    eval 'sub M_NFSUID {51;}';
    eval 'sub M_NFSD {52;}';
    eval 'sub M_IPMOPTS {53;}';
    eval 'sub M_IPMADDR {54;}';
    eval 'sub M_IFMADDR {55;}';
    eval 'sub M_MRTABLE {56;}';
    eval 'sub M_ISOFSMNT {57;}';
    eval 'sub M_ISOFSNODE {58;}';
    eval 'sub M_MSDOSFSMNT {59;}';
    eval 'sub M_MSDOSFSNODE {60;}';
    eval 'sub M_MSDOSFSFAT {61;}';
    eval 'sub M_DEVFSMNT {62;}';
    eval 'sub M_DEVFSBACK {63;}';
    eval 'sub M_DEVFSFRONT {64;}';
    eval 'sub M_DEVFSNODE {65;}';
    eval 'sub M_TEMP {74;}';
    eval 'sub M_TTYS {75;}';
    eval 'sub M_GZIP {76;}';
    eval 'sub M_IPFW {77;}';
    eval 'sub M_DEVL {78;}';
    eval 'sub M_LAST {79;}';
    eval 'sub INITKMEMNAMES {{ "free", "mbuf", "devbuf", "socket", "pcb", "routetbl", "hosttbl", "fragtbl", "zombie", "ifaddr", "soopts", "soname", "namei", "gprof", "ioctlops", "mapmem", "cred", "pgrp", "session", "iov", "mount", "fhandle", "NFS req", "NFS mount", "NFS node", "vnodes", "namecache", "UFS quota", "UFS mount", "shm", "VM map", "VM mapent", "VM object", "VM objhash", "VM pmap", "VM pvmap", "VM pager", "VM pgdata", "file", "file desc", "lockf", "proc", "subproc", "LFS segment", "LFS node", "FFS node", "MFS node", "NQNFS Lease", "NQNFS Host", "Export Host", "NFS srvsock", "NFS uid", "NFS daemon", "ip_moptions", "in_multi", "ether_multi", "mrt", "ISOFS mount", "ISOFS node", "MSDOSFS mount", "MSDOSFS node", "MSDOSFS FAT", "DEVFS mount", "DEVFS back", "DEVFS front", "DEVFS node", defined &NULL && &NULL, defined &NULL && &NULL, defined &NULL && &NULL, defined &NULL && &NULL, defined &NULL && &NULL, defined &NULL && &NULL, defined &NULL && &NULL, defined &NULL && &NULL, "temp", "ttys", "Gzip trees", "IpFw/IpAcct", "isa_devlist", };}';
    eval 'sub ku_freecnt {defined &ku_un && &ku_un.defined &freecnt && &freecnt;}';
    eval 'sub ku_pagecnt {defined &ku_un && &ku_un.defined &pagecnt && &pagecnt;}';
    if (defined &KERNEL) {
	eval 'sub MINALLOCSIZE {(1 << defined &MINBUCKET && &MINBUCKET);}';
	eval 'sub BUCKETINDX {
	    local($size) = @_;
	    eval "($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 128) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 8) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 2) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 1) ? (defined &MINBUCKET && &MINBUCKET + 0) : (defined &MINBUCKET && &MINBUCKET + 1) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 4) ? (defined &MINBUCKET && &MINBUCKET + 2) : (defined &MINBUCKET && &MINBUCKET + 3) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE* 32) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 16) ? (defined &MINBUCKET && &MINBUCKET + 4) : (defined &MINBUCKET && &MINBUCKET + 5) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 64) ? (defined &MINBUCKET && &MINBUCKET + 6) : (defined &MINBUCKET && &MINBUCKET + 7) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 2048) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 512) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 256) ? (defined &MINBUCKET && &MINBUCKET + 8) : (defined &MINBUCKET && &MINBUCKET + 9) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 1024) ? (defined &MINBUCKET && &MINBUCKET + 10) : (defined &MINBUCKET && &MINBUCKET + 11) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 8192) ? ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 4096) ? (defined &MINBUCKET && &MINBUCKET + 12) : (defined &MINBUCKET && &MINBUCKET + 13) : ($size) <= (defined &MINALLOCSIZE && &MINALLOCSIZE * 16384) ? (defined &MINBUCKET && &MINBUCKET + 14) : (defined &MINBUCKET && &MINBUCKET + 15)";
	}';
	eval 'sub kmemxtob {
	    local($alloc) = @_;
	    eval "(defined &kmembase && &kmembase + ($alloc) * defined &NBPG && &NBPG)";
	}';
	eval 'sub btokmemx {
	    local($addr) = @_;
	    eval "(((defined &caddr_t && &caddr_t)($addr) - defined &kmembase && &kmembase) / defined &NBPG && &NBPG)";
	}';
	eval 'sub btokup {
	    local($addr) = @_;
	    eval "(&defined &kmemusage && &kmemusage[((defined &caddr_t && &caddr_t)($addr) - defined &kmembase && &kmembase) >> defined &CLSHIFT && &CLSHIFT])";
	}';
	if ( defined( &KMEMSTATS) || defined( &DIAGNOSTIC)) {
	    eval 'sub MALLOC {
	        local($space, $cast, $size, $type, $flags) = @_;
	        eval "($space) = ($cast) &malloc(($size), $type, $flags)";
	    }';
	    eval 'sub FREE {
	        local($addr, $type) = @_;
	        eval " &free((defined &caddr_t && &caddr_t)($addr), $type)";
	    }';
	}
	else {
	    eval 'sub MALLOC {
	        local($space, $cast, $size, $type, $flags) = @_;
	        eval "{ \'long\' defined &indx && &indx =  &BUCKETINDX($size); defined &register && &register struct kmembuckets *defined &kbp && &kbp = &defined &bucket && &bucket[defined &indx && &indx]; long defined &s && &s =  &splimp(); defined &if && &if (defined &kbp && &kbp->defined &kb_next && &kb_next == defined &NULL && &NULL) { ($space) = ($cast) &malloc_with_index(($size), $type, $flags, defined &indx && &indx); } defined &else && &else { ($space) = ($cast)defined &kbp && &kbp->defined &kb_next && &kb_next; defined &kbp && &kbp->defined &kb_next && &kb_next = *(defined &caddr_t && &caddr_t *)($space); }  &splx(defined &s && &s); }";
	    }';
	    eval 'sub FREE {
	        local($addr, $type) = @_;
	        eval "{ defined &register && &register struct kmembuckets *defined &kbp && &kbp; defined &register && &register struct kmemusage *defined &kup && &kup =  &btokup($addr); long defined &s && &s =  &splimp(); defined &if && &if (1 << defined &kup && &kup->defined &ku_indx && &ku_indx > defined &MAXALLOCSAVE && &MAXALLOCSAVE) {  &free((defined &caddr_t && &caddr_t)($addr), $type); } defined &else && &else { defined &kbp && &kbp = &defined &bucket && &bucket[defined &kup && &kup->defined &ku_indx && &ku_indx]; defined &if && &if (defined &kbp && &kbp->defined &kb_next && &kb_next == defined &NULL && &NULL) defined &kbp && &kbp->defined &kb_next && &kb_next = (defined &caddr_t && &caddr_t)($addr); defined &else && &else *(defined &caddr_t && &caddr_t *)(defined &kbp && &kbp->defined &kb_last && &kb_last) = (defined &caddr_t && &caddr_t)($addr); *(defined &caddr_t && &caddr_t *)($addr) = defined &NULL && &NULL; defined &kbp && &kbp->defined &kb_last && &kb_last = (defined &caddr_t && &caddr_t)($addr); }  &splx(defined &s && &s); }";
	    }';
	}
    }
}
1;
