if (!defined &_SYS_TTY_H_) {
    eval 'sub _SYS_TTY_H_ {1;}';
    require 'sys/termios.ph';
    require 'sys/select.ph';
    eval 'sub t_cc {defined &t_termios && &t_termios.defined &c_cc && &c_cc;}';
    eval 'sub t_cflag {defined &t_termios && &t_termios.defined &c_cflag && &c_cflag;}';
    eval 'sub t_iflag {defined &t_termios && &t_termios.defined &c_iflag && &c_iflag;}';
    eval 'sub t_ispeed {defined &t_termios && &t_termios.defined &c_ispeed && &c_ispeed;}';
    eval 'sub t_lflag {defined &t_termios && &t_termios.defined &c_lflag && &c_lflag;}';
    eval 'sub t_min {defined &t_termios && &t_termios.defined &c_min && &c_min;}';
    eval 'sub t_oflag {defined &t_termios && &t_termios.defined &c_oflag && &c_oflag;}';
    eval 'sub t_ospeed {defined &t_termios && &t_termios.defined &c_ospeed && &c_ospeed;}';
    eval 'sub t_time {defined &t_termios && &t_termios.defined &c_time && &c_time;}';
    eval 'sub TTIPRI {25;}';
    eval 'sub TTOPRI {26;}';
    eval 'sub IBUFSIZ {384;}';
    eval 'sub OBUFSIZ {100;}';
    if (!defined &TTYHOG) {
	eval 'sub TTYHOG {1024;}';
    }
    if (defined &KERNEL) {
	eval 'sub TTMAXHIWAT { &roundup(2048, defined &CBSIZE && &CBSIZE);}';
	eval 'sub TTMINHIWAT { &roundup(100, defined &CBSIZE && &CBSIZE);}';
	eval 'sub TTMAXLOWAT {256;}';
	eval 'sub TTMINLOWAT {32;}';
    }
    eval 'sub TS_SO_OLOWAT {0x00001;}';
    eval 'sub TS_ASYNC {0x00002;}';
    eval 'sub TS_BUSY {0x00004;}';
    eval 'sub TS_CARR_ON {0x00008;}';
    eval 'sub TS_FLUSH {0x00010;}';
    eval 'sub TS_ISOPEN {0x00020;}';
    eval 'sub TS_TBLOCK {0x00040;}';
    eval 'sub TS_TIMEOUT {0x00080;}';
    eval 'sub TS_TTSTOP {0x00100;}';
    if (defined &notyet) {
	eval 'sub TS_WOPEN {0x00200;}';
    }
    eval 'sub TS_XCLUDE {0x00400;}';
    eval 'sub TS_BKSL {0x00800;}';
    eval 'sub TS_CNTTB {0x01000;}';
    eval 'sub TS_ERASE {0x02000;}';
    eval 'sub TS_LNCH {0x04000;}';
    eval 'sub TS_TYPEN {0x08000;}';
    eval 'sub TS_LOCAL {(defined &TS_BKSL && &TS_BKSL | defined &TS_CNTTB && &TS_CNTTB | defined &TS_ERASE && &TS_ERASE | defined &TS_LNCH && &TS_LNCH | defined &TS_TYPEN && &TS_TYPEN);}';
    eval 'sub TS_CAN_BYPASS_L_RINT {0x010000;}';
    eval 'sub TS_CONNECTED {0x020000;}';
    eval 'sub TS_SNOOP {0x040000;}';
    eval 'sub TS_SO_OCOMPLETE {0x080000;}';
    eval 'sub TS_ZOMBIE {0x100000;}';
    eval 'sub TS_CAR_OFLOW {0x200000;}';
    if (defined &notyet) {
	eval 'sub TS_CTS_OFLOW {0x400000;}';
	eval 'sub TS_DSR_OFLOW {0x800000;}';
    }
    eval 'sub ORDINARY {0;}';
    eval 'sub CONTROL {1;}';
    eval 'sub BACKSPACE {2;}';
    eval 'sub NEWLINE {3;}';
    eval 'sub TAB {4;}';
    eval 'sub VTAB {5;}';
    eval 'sub RETURN {6;}';
    eval 'sub DMSET {0;}';
    eval 'sub DMBIS {1;}';
    eval 'sub DMBIC {2;}';
    eval 'sub DMGET {3;}';
    eval 'sub TTY_CHARMASK {0x000000ff;}';
    eval 'sub TTY_QUOTE {0x00000100;}';
    eval 'sub TTY_ERRORMASK {0xff000000;}';
    eval 'sub TTY_FE {0x01000000;}';
    eval 'sub TTY_PE {0x02000000;}';
    eval 'sub TTY_OE {0x04000000;}';
    eval 'sub TTY_BI {0x08000000;}';
    eval 'sub isctty {
        local($p, $tp) = @_;
        eval "(($p)->defined &p_session && &p_session == ($tp)->defined &t_session && &t_session && ($p)->defined &p_flag && &p_flag & defined &P_CONTROLT && &P_CONTROLT)";
    }';
    eval 'sub isbackground {
        local($p, $tp) = @_;
        eval "( &isctty(($p), ($tp)) && ($p)->defined &p_pgrp && &p_pgrp != ($tp)->defined &t_pgrp && &t_pgrp)";
    }';
    eval 'sub TSA_CARR_ON {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_rawq && &t_rawq)";
    }';
    eval 'sub TSA_HUP_OR_INPUT {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_rawq && &t_rawq.defined &c_cf && &c_cf)";
    }';
    eval 'sub TSA_OCOMPLETE {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_outq && &t_outq.defined &c_cl && &c_cl)";
    }';
    eval 'sub TSA_OLOWAT {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_outq && &t_outq)";
    }';
    eval 'sub TSA_PTC_READ {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_outq && &t_outq.defined &c_cf && &c_cf)";
    }';
    eval 'sub TSA_PTC_WRITE {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_rawq && &t_rawq.defined &c_cl && &c_cl)";
    }';
    eval 'sub TSA_PTS_READ {
        local($tp) = @_;
        eval "((defined &void && &void *)&($tp)->defined &t_canq && &t_canq)";
    }';
    if (defined &KERNEL) {
    }
}
1;
