###############################################################################
#
# The set defines the state table used to erase html tags.
#
#	states_number:		number of states in table
#	outside_tag_state:	number of default state outside of <> tag
#	inside_tag_state:	number of state corresponds to HTML tag initialization
#	erasure_state:		number of state where erasure of kw takes place
#	keyword:
#		id:		unique activity identifier in the range 1..32 (0 -> empty)
#		switch:
#			from_state:	initial state
#			if_char:	characters that triggers state change
#			to_state:	switch to that state
# 
###############################################################################

(
 	:states_number (22)
	:outside_tag_state (0)
	:inside_tag_state (1)
 	:erasure_state (21)
	:keyword	(		# mutual "<" (optional whitespaces) ___________________
		:id	(0)
		:switch (
			:from_state (0)
			:if_char ("<")
			:to_state (1)
		)
		:switch (
			:from_state (1)
			:if_char (" 	
")
			:to_state (1)
		)
	)
	:keyword	(		# "applet" ____________________________________________
		:id	(1)
		:switch (
			:from_state (1)
			:if_char ("Aa")
			:to_state (2)
		)
		:switch (
			:from_state (2)
			:if_char ("Pp")
			:to_state (3)
		)
		:switch (
			:from_state (3)
			:if_char ("Pp")
			:to_state (4)
		)
		:switch (
			:from_state (4)
			:if_char ("Ll")
			:to_state (5)
		)
		:switch (
			:from_state (5)
			:if_char ("Ee")
			:to_state (6)
		)
		:switch (
			:from_state (6)
			:if_char ("Tt")
			:to_state (21)
		)
	)
	:keyword	(		# "script" ____________________________________________
		:id	(2)
		:switch (
			:from_state (1)
			:if_char ("Ss")
			:to_state (7)
		)
		:switch (
			:from_state (7)
			:if_char ("Cc")
			:to_state (8)
		)
		:switch (
			:from_state (8)
			:if_char ("Rr")
			:to_state (9)
		)
		:switch (
			:from_state (9)
			:if_char ("Ii")
			:to_state (10)
		)
		:switch (
			:from_state (10)
			:if_char ("Pp")
			:to_state (11)
		)
		:switch (
			:from_state (11)
			:if_char ("Tt")
			:to_state (21)
		)
	)
	:keyword	(		# "object" ____________________________________________
		:id	(4)
		:switch (
			:from_state (1)
			:if_char ("Oo")
			:to_state (12)
		)
		:switch (
			:from_state (12)
			:if_char ("Bb")
			:to_state (13)
		)
		:switch (
			:from_state (13)
			:if_char ("Jj")
			:to_state (14)
		)
		:switch (
			:from_state (14)
			:if_char ("Ee")
			:to_state (15)
		)
		:switch (
			:from_state (15)
			:if_char ("Cc")
			:to_state (16)
		)
		:switch (
			:from_state (16)
			:if_char ("Tt")
			:to_state (21)
		)
	)
	:keyword	(		# "embed" _____________________________________________
		:id	(8)
		:switch (
			:from_state (1)
			:if_char ("Ee")
			:to_state (17)
		)
		:switch (
			:from_state (17)
			:if_char ("Mm")
			:to_state (18)
		)
		:switch (
			:from_state (18)
			:if_char ("Bb")
			:to_state (19)
		)
		:switch (
			:from_state (19)
			:if_char ("Ee")
			:to_state (20)
		)
		:switch (
			:from_state (20)
			:if_char ("Dd")
			:to_state (21)
		)
	)
)
