#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

sub get {
  local($thing) = @_;
  open (FD, "/usr/local/config/bin/dbget $thing |");
  $result=<FD>;
  close(FD);
  chop($result);
  return($result);
}

sub GetIpsInfo {
    local($IPSSYSCTL)       = "/usr/sbin/sysctl";
    local($CTLMIBOBJ)       = "ips.switch";
    local($_);

    if(!open(READSYSCTL, "$IPSSYSCTL $CTLMIBOBJ | ")) {
	print "couldn't find sysctl!\n";
    }
    $cnt = 0;
    while (<READSYSCTL>) {
	chop;
	$cnt++;
    };
    if ($cnt > 0) {
	$IPSDEVTYPE = "controller";
    }else{
	$IPSDEVTYPE = "gateway";
    }
    #$machine=&get("machine");
    #
    #$IPSDEVTYPE=&get("machine:${machine}:type"); 
    #if (!$IPSDEVTYPE) {
    #    $IPSDEVTYPE= "controller";
    #}
    #local($_);
}

sub	GetTypeSpecific {
	local($_);

	if ($IPSDEVTYPE eq "controller") {
		require 'ipsw-lib.pl';
		&ParseSysctl("ips.switch");
		if ($ips_data{"ips.switch\[1\].type"} eq "3")
			{ $IPSSWITCHTYPE= "ATML"; $switch_tmpl = "$ATMLTMPL"; }
		elsif ($ips_data{"ips.switch\[1\].type"} eq "4")
			{ $IPSSWITCHTYPE= "SPINOLI"; $switch_tmpl = "$SPINOLITMPL"; }
		elsif ($ips_data{"ips.switch\[1\].type"} eq "5")
			{ $IPSSWITCHTYPE= "DEC"; $switch_tmpl = "$DECTMPL"; }
	} elsif ($IPSDEVTYPE eq "gateway") { 
	    require 'ipswgw-lib.pl'; $switch_tmpl = "$IPSWGWTMPL"; 
	} else {
	    require 'ipswgw-lib.pl'; $switch_tmpl = "$IPSWGWTMPL";  # BOGUS @@
	}
	&InitPortMap; &ParseIflistSysctl(); &ParseSysctl("ips");
	return;
}

1;
