if (!defined &_BITSTRING_H_) {
    eval 'sub _BITSTRING_H_ {1;}';
    eval 'sub _bit_byte {
        local($bit) = @_;
        eval "(($bit) >> 3)";
    }';
    eval 'sub _bit_mask {
        local($bit) = @_;
        eval "(1 << (($bit)&0x7))";
    }';
    eval 'sub bitstr_size {
        local($nbits) = @_;
        eval "(((($nbits) - 1) >> 3) + 1)";
    }';
    eval 'sub bit_alloc {
        local($nbits) = @_;
        eval "(defined &bitstr_t && &bitstr_t *) &calloc(1,  &bitstr_size($nbits) * $sizeof{defined &bitstr_t && &bitstr_t})";
    }';
    eval 'sub bit_decl {
        local($name, $nbits) = @_;
        eval "($name)[ &bitstr_size($nbits)]";
    }';
    eval 'sub bit_test {
        local($name, $bit) = @_;
        eval "(($name)[ &_bit_byte($bit)] &  &_bit_mask($bit))";
    }';
    eval 'sub bit_set {
        local($name, $bit) = @_;
        eval "($name)[ &_bit_byte($bit)] |=  &_bit_mask($bit)";
    }';
    eval 'sub bit_clear {
        local($name, $bit) = @_;
        eval "($name)[ &_bit_byte($bit)] &= ~ &_bit_mask($bit)";
    }';
    eval 'sub bit_nclear {
        local($name, $start, $stop) = @_;
        eval "{ defined &register && &register defined &bitstr_t && &bitstr_t *defined &_name && &_name = $name; defined &register && &register int defined &_start && &_start = $start, defined &_stop && &_stop = $stop; defined &register && &register int defined &_startbyte && &_startbyte =  &_bit_byte(defined &_start && &_start); defined &register && &register int defined &_stopbyte && &_stopbyte =  &_bit_byte(defined &_stop && &_stop); defined &if && &if (defined &_startbyte && &_startbyte == defined &_stopbyte && &_stopbyte) { defined &_name && &_name[defined &_startbyte && &_startbyte] &= ((0xff >> (8 - (defined &_start && &_start&0x7))) | (0xff << ((defined &_stop && &_stop&0x7) + 1))); } defined &else && &else { defined &_name && &_name[defined &_startbyte && &_startbyte] &= 0xff >> (8 - (defined &_start && &_start&0x7)); defined &while && &while (++defined &_startbyte && &_startbyte < defined &_stopbyte && &_stopbyte) defined &_name && &_name[defined &_startbyte && &_startbyte] = 0; defined &_name && &_name[defined &_stopbyte && &_stopbyte] &= 0xff << ((defined &_stop && &_stop&0x7) + 1); } }";
    }';
    eval 'sub bit_nset {
        local($name, $start, $stop) = @_;
        eval "{ defined &register && &register defined &bitstr_t && &bitstr_t *defined &_name && &_name = $name; defined &register && &register int defined &_start && &_start = $start, defined &_stop && &_stop = $stop; defined &register && &register int defined &_startbyte && &_startbyte =  &_bit_byte(defined &_start && &_start); defined &register && &register int defined &_stopbyte && &_stopbyte =  &_bit_byte(defined &_stop && &_stop); defined &if && &if (defined &_startbyte && &_startbyte == defined &_stopbyte && &_stopbyte) { defined &_name && &_name[defined &_startbyte && &_startbyte] |= ((0xff << (defined &_start && &_start&0x7)) & (0xff >> (7 - (defined &_stop && &_stop&0x7)))); } defined &else && &else { defined &_name && &_name[defined &_startbyte && &_startbyte] |= 0xff << ((defined &_start && &_start)&0x7); defined &while && &while (++defined &_startbyte && &_startbyte < defined &_stopbyte && &_stopbyte) defined &_name && &_name[defined &_startbyte && &_startbyte] = 0xff; defined &_name && &_name[defined &_stopbyte && &_stopbyte] |= 0xff >> (7 - (defined &_stop && &_stop&0x7)); } }";
    }';
    eval 'sub bit_ffc {
        local($name, $nbits, $value) = @_;
        eval "{ defined &register && &register defined &bitstr_t && &bitstr_t *defined &_name && &_name = $name; defined &register && &register int defined &_byte && &_byte, defined &_nbits && &_nbits = $nbits; defined &register && &register int defined &_stopbyte && &_stopbyte =  &_bit_byte(defined &_nbits && &_nbits), defined &_value && &_value = -1; defined &for && &for (defined &_byte && &_byte = 0; defined &_byte && &_byte <= defined &_stopbyte && &_stopbyte; ++defined &_byte && &_byte) defined &if && &if (defined &_name && &_name[defined &_byte && &_byte] != 0xff) { defined &_value && &_value = defined &_byte && &_byte << 3; defined &for && &for (defined &_stopbyte && &_stopbyte = defined &_name && &_name[defined &_byte && &_byte]; (defined &_stopbyte && &_stopbyte&0x1); ++defined &_value && &_value, defined &_stopbyte && &_stopbyte >>= 1); defined &break && &break; } *($value) = defined &_value && &_value; }";
    }';
    eval 'sub bit_ffs {
        local($name, $nbits, $value) = @_;
        eval "{ defined &register && &register defined &bitstr_t && &bitstr_t *defined &_name && &_name = $name; defined &register && &register int defined &_byte && &_byte, defined &_nbits && &_nbits = $nbits; defined &register && &register int defined &_stopbyte && &_stopbyte =  &_bit_byte(defined &_nbits && &_nbits), defined &_value && &_value = -1; defined &for && &for (defined &_byte && &_byte = 0; defined &_byte && &_byte <= defined &_stopbyte && &_stopbyte; ++defined &_byte && &_byte) defined &if && &if (defined &_name && &_name[defined &_byte && &_byte]) { defined &_value && &_value = defined &_byte && &_byte << 3; defined &for && &for (defined &_stopbyte && &_stopbyte = defined &_name && &_name[defined &_byte && &_byte]; !(defined &_stopbyte && &_stopbyte&0x1); ++defined &_value && &_value, defined &_stopbyte && &_stopbyte >>= 1); defined &break && &break; } *($value) = defined &_value && &_value; }";
    }';
}
1;
