if (!defined &_SYS_MBUF_H_) {
    eval 'sub _SYS_MBUF_H_ {1;}';
    if (!defined &M_WAITOK) {
	require 'sys/malloc.ph';
    }
    eval 'sub MLEN {(defined &MSIZE && &MSIZE - $sizeof{\'struct m_hdr\'});}';
    eval 'sub MHLEN {(defined &MLEN && &MLEN - $sizeof{\'struct pkthdr\'});}';
    eval 'sub MINCLSIZE {(defined &MHLEN && &MHLEN + defined &MLEN && &MLEN);}';
    eval 'sub M_MAXCOMPRESS {(defined &MHLEN && &MHLEN / 2);}';
    eval 'sub mtod {
        local($m,$t) = @_;
        eval "(($t)(($m)->defined &m_data && &m_data))";
    }';
    eval 'sub dtom {
        local($x) = @_;
        eval "((($x) & ~(defined &MSIZE && &MSIZE-1)))";
    }';
    eval 'sub mtocl {
        local($x) = @_;
        eval "((($x) - defined &mbutl && &mbutl) >> defined &MCLSHIFT && &MCLSHIFT)";
    }';
    eval 'sub cltom {
        local($x) = @_;
        eval "((defined &caddr_t && &caddr_t)(defined &mbutl && &mbutl + (($x) << defined &MCLSHIFT && &MCLSHIFT)))";
    }';
    eval 'sub m_next {defined &m_hdr && &m_hdr.defined &mh_next && &mh_next;}';
    eval 'sub m_len {defined &m_hdr && &m_hdr.defined &mh_len && &mh_len;}';
    eval 'sub m_data {defined &m_hdr && &m_hdr.defined &mh_data && &mh_data;}';
    eval 'sub m_type {defined &m_hdr && &m_hdr.defined &mh_type && &mh_type;}';
    eval 'sub m_flags {defined &m_hdr && &m_hdr.defined &mh_flags && &mh_flags;}';
    eval 'sub m_nextpkt {defined &m_hdr && &m_hdr.defined &mh_nextpkt && &mh_nextpkt;}';
    eval 'sub m_act {defined &m_nextpkt && &m_nextpkt;}';
    eval 'sub m_pkthdr {defined &M_dat && &M_dat.defined &MH && &MH.defined &MH_pkthdr && &MH_pkthdr;}';
    eval 'sub m_ext {defined &M_dat && &M_dat.defined &MH && &MH.defined &MH_dat && &MH_dat.defined &MH_ext && &MH_ext;}';
    eval 'sub m_pktdat {defined &M_dat && &M_dat.defined &MH && &MH.defined &MH_dat && &MH_dat.defined &MH_databuf && &MH_databuf;}';
    eval 'sub m_dat {defined &M_dat && &M_dat.defined &M_databuf && &M_databuf;}';
    eval 'sub M_EXT {0x0001;}';
    eval 'sub M_PKTHDR {0x0002;}';
    eval 'sub M_EOR {0x0004;}';
    eval 'sub M_ALLOCED {0x0008;}';
    eval 'sub M_BCAST {0x0100;}';
    eval 'sub M_MCAST {0x0200;}';
    eval 'sub M_COPYFLAGS {(defined &M_PKTHDR && &M_PKTHDR|defined &M_EOR && &M_EOR|defined &M_BCAST && &M_BCAST|defined &M_MCAST && &M_MCAST);}';
    eval 'sub MT_FREE {0;}';
    eval 'sub MT_DATA {1;}';
    eval 'sub MT_HEADER {2;}';
    eval 'sub MT_SOCKET {3;}';
    eval 'sub MT_PCB {4;}';
    eval 'sub MT_RTABLE {5;}';
    eval 'sub MT_HTABLE {6;}';
    eval 'sub MT_ATABLE {7;}';
    eval 'sub MT_SONAME {8;}';
    eval 'sub MT_SOOPTS {10;}';
    eval 'sub MT_FTABLE {11;}';
    eval 'sub MT_RIGHTS {12;}';
    eval 'sub MT_IFADDR {13;}';
    eval 'sub MT_CONTROL {14;}';
    eval 'sub MT_OOBDATA {15;}';
    eval 'sub MT_IPSBUF {16;}';
    eval 'sub M_DONTWAIT {defined &M_NOWAIT && &M_NOWAIT;}';
    eval 'sub M_WAIT {defined &M_WAITOK && &M_WAITOK;}';
    eval 'sub MBUFLOCK {
        local($code) = @_;
        eval "{ \'int\' defined &ms && &ms =  &splimp(); { $code }  &splx(defined &ms && &ms); }";
    }';
    eval 'sub LOCKED_FMBFREE {
        local($m) = @_;
        eval "{ defined &if && &if ((($m)->defined &m_flags && &m_flags & defined &M_ALLOCED && &M_ALLOCED) == 0) { ($m)->defined &m_next && &m_next = defined &ipsmbfree && &ipsmbfree; defined &ipsmbfree && &ipsmbfree = ($m); defined &mbstat && &mbstat.defined &m_fmbufsfree && &m_fmbufsfree++; } defined &else && &else {  &FREE(($m), defined &mbtypes && &mbtypes[($m)->defined &m_type && &m_type]); }}";
    }';
    eval 'sub FMBFREE {
        local($m) = @_;
        eval " &MBUFLOCK(  &LOCKED_FMBFREE($m); )";
    }';
    eval 'sub LOCKED_MGETHDR {
        local($m, $how, $type) = @_;
        eval "{ defined &if && &if ((($m) = defined &ipsmbfree && &ipsmbfree)) { defined &mbstat && &mbstat.defined &m_fmbufsfree && &m_fmbufsfree--; defined &ipsmbfree && &ipsmbfree = ($m)->defined &m_next && &m_next; ($m)->defined &m_next && &m_next = defined &NULL && &NULL; ($m)->defined &m_nextpkt && &m_nextpkt = defined &NULL && &NULL; ($m)->defined &m_data && &m_data = ($m)->defined &m_pktdat && &m_pktdat; ($m)->defined &m_type && &m_type = ($type); ($m)->defined &m_flags && &m_flags = defined &M_PKTHDR && &M_PKTHDR; } defined &else && &else { defined &if && &if (($how) == defined &M_WAIT && &M_WAIT) {  &MALLOC(($m), struct mbuf *, defined &MSIZE && &MSIZE, defined &mbtypes && &mbtypes[$type], ($how)); defined &if && &if ($m) { ($m)->defined &m_next && &m_next = defined &NULL && &NULL; ($m)->defined &m_nextpkt && &m_nextpkt = defined &NULL && &NULL; ($m)->defined &m_data && &m_data = ($m)->defined &m_pktdat && &m_pktdat; ($m)->defined &m_type && &m_type = ($type); ($m)->defined &m_flags && &m_flags = (defined &M_PKTHDR && &M_PKTHDR|defined &M_ALLOCED && &M_ALLOCED); } } defined &else && &else defined &mbstat && &mbstat.defined &m_fmbdrops && &m_fmbdrops++; } }";
    }';
    eval 'sub MGETHDR {
        local($m, $how, $type) = @_;
        eval "{  &MBUFLOCK(  &LOCKED_MGETHDR($m, $how, $type); ) }";
    }';
    eval 'sub LOCKED_MGET {
        local($m, $how, $type) = @_;
        eval "{ defined &if && &if ((($m) = defined &ipsmbfree && &ipsmbfree)) { defined &ipsmbfree && &ipsmbfree = ($m)->defined &m_next && &m_next; defined &mbstat && &mbstat.defined &m_fmbufsfree && &m_fmbufsfree--; ($m)->defined &m_next && &m_next = defined &NULL && &NULL; ($m)->defined &m_nextpkt && &m_nextpkt = defined &NULL && &NULL; ($m)->defined &m_data && &m_data = ($m)->defined &m_dat && &m_dat; ($m)->defined &m_type && &m_type = ($type); ($m)->defined &m_flags && &m_flags = 0; } defined &else && &else { defined &if && &if (($how) == defined &M_WAIT && &M_WAIT) {  &MALLOC(($m), struct mbuf *, defined &MSIZE && &MSIZE, defined &mbtypes && &mbtypes[$type], ($how)); defined &if && &if ($m) { ($m)->defined &m_next && &m_next = defined &NULL && &NULL; ($m)->defined &m_nextpkt && &m_nextpkt = defined &NULL && &NULL; ($m)->defined &m_data && &m_data = ($m)->defined &m_dat && &m_dat; ($m)->defined &m_type && &m_type = ($type); ($m)->defined &m_flags && &m_flags = defined &M_ALLOCED && &M_ALLOCED; } } defined &else && &else defined &mbstat && &mbstat.defined &m_fmbdrops && &m_fmbdrops++; } }";
    }';
    eval 'sub MGET {
        local($m, $how, $type) = @_;
        eval "{  &MBUFLOCK(  &LOCKED_MGET($m, $how, $type); ) }";
    }';
    eval 'sub MCLALLOC {
        local($p, $how) = @_;
        eval " &MBUFLOCK( defined &if && &if (defined &mclfree && &mclfree == 0) (defined &void && &void) &m_clalloc(1, ($how)); ($p) = (defined &caddr_t && &caddr_t)defined &mclfree && &mclfree; defined &if && &if (($p)) { ++defined &mclrefcnt && &mclrefcnt[ &mtocl($p)]; defined &mbstat && &mbstat.defined &m_clfree && &m_clfree--; defined &mclfree && &mclfree = ((defined &union && &union defined &mcluster && &mcluster *)($p))->defined &mcl_next && &mcl_next; } )";
    }';
    eval 'sub MCLGET {
        local($m, $how) = @_;
        eval "{  &MCLALLOC(($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf, ($how)); defined &if && &if (($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf != defined &NULL && &NULL) { ($m)->defined &m_data && &m_data = ($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf; ($m)->defined &m_flags && &m_flags |= defined &M_EXT && &M_EXT; ($m)->defined &m_ext && &m_ext.defined &ext_size && &ext_size = defined &MCLBYTES && &MCLBYTES; } }";
    }';
    eval 'sub MCLFREE {
        local($p) = @_;
        eval "{ defined &MBUFLOCK && &MBUFLOCK ( defined &union && &union defined &mcluster && &mcluster * defined &__mcl && &__mcl = (defined &union && &union defined &mcluster && &mcluster *) ($p); defined &if && &if (--defined &mclrefcnt && &mclrefcnt[ &mtocl(defined &__mcl && &__mcl)] == 0) { defined &__mcl && &__mcl->defined &mcl_next && &mcl_next = defined &mclfree && &mclfree; defined &mclfree && &mclfree = defined &__mcl && &__mcl; defined &mbstat && &mbstat.defined &m_clfree && &m_clfree++; } ) }";
    }';
    eval 'sub LOCKED_MCLALLOC {
        local($p, $how) = @_;
        eval "defined &if && &if (defined &mclfree && &mclfree == 0) (defined &void && &void) &m_clalloc(1, ($how)); ($p) = (defined &caddr_t && &caddr_t)defined &mclfree && &mclfree; defined &if && &if (($p)) { ++defined &mclrefcnt && &mclrefcnt[ &mtocl($p)]; defined &mbstat && &mbstat.defined &m_clfree && &m_clfree--; defined &mclfree && &mclfree = ((defined &union && &union defined &mcluster && &mcluster *)($p))->defined &mcl_next && &mcl_next; }";
    }';
    eval 'sub LOCKED_MCLGET {
        local($m, $how) = @_;
        eval "{  &LOCKED_MCLALLOC(($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf, ($how)); defined &if && &if (($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf != defined &NULL && &NULL) { ($m)->defined &m_data && &m_data = ($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf; ($m)->defined &m_flags && &m_flags |= defined &M_EXT && &M_EXT; ($m)->defined &m_ext && &m_ext.defined &ext_size && &ext_size = defined &MCLBYTES && &MCLBYTES; } }";
    }';
    eval 'sub LOCKED_MCLFREE {
        local($p) = @_;
        eval "{ defined &union && &union defined &mcluster && &mcluster * defined &__mcl && &__mcl = (defined &union && &union defined &mcluster && &mcluster *) ($p); defined &if && &if (--defined &mclrefcnt && &mclrefcnt[ &mtocl(defined &__mcl && &__mcl)] == 0) { defined &__mcl && &__mcl->defined &mcl_next && &mcl_next = defined &mclfree && &mclfree; defined &mclfree && &mclfree = defined &__mcl && &__mcl; defined &mbstat && &mbstat.defined &m_clfree && &m_clfree++; } }";
    }';
    if (defined &notyet) {
	eval 'sub MFREE {
	    local($m, $n) = @_;
	    eval "{  &MBUFLOCK(defined &mbstat && &mbstat.defined &m_mtypes && &m_mtypes[($m)->defined &m_type && &m_type]--;) defined &if && &if (($m)->defined &m_flags && &m_flags & defined &M_EXT && &M_EXT) { defined &if && &if (($m)->defined &m_ext && &m_ext.defined &ext_free && &ext_free) (*(($m)->defined &m_ext && &m_ext.defined &ext_free && &ext_free))(($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf, ($m)->defined &m_ext && &m_ext.defined &ext_size && &ext_size); defined &else && &else  &MCLFREE(($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf); } ($n) = ($m)->defined &m_next && &m_next;  &FREE(($m), defined &mbtypes && &mbtypes[($m)->defined &m_type && &m_type]); }";
	}';
    }
    else {
	eval 'sub MFREE {
	    local($m, $nn) = @_;
	    eval "{ defined &if && &if (($m)->defined &m_flags && &m_flags & defined &M_EXT && &M_EXT) {  &MCLFREE(($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf); } ($nn) = ($m)->defined &m_next && &m_next;  &FMBFREE($m); }";
	}';
	eval 'sub LOCKED_MFREE {
	    local($m, $nn) = @_;
	    eval "{ defined &if && &if (($m)->defined &m_flags && &m_flags & defined &M_EXT && &M_EXT) {  &LOCKED_MCLFREE(($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf); } ($nn) = ($m)->defined &m_next && &m_next;  &LOCKED_FMBFREE($m); }";
	}';
    }
    eval 'sub M_COPY_PKTHDR {
        local($to, $from) = @_;
        eval "{ ($to)->defined &m_pkthdr && &m_pkthdr = ($from)->defined &m_pkthdr && &m_pkthdr; ($to)->defined &m_flags && &m_flags = ($from)->defined &m_flags && &m_flags & defined &M_COPYFLAGS && &M_COPYFLAGS; ($to)->defined &m_data && &m_data = ($to)->defined &m_pktdat && &m_pktdat; }";
    }';
    eval 'sub M_ALIGN {
        local($m, $len) = @_;
        eval "{ ($m)->defined &m_data && &m_data += (defined &MLEN && &MLEN - ($len)) &~ ($sizeof{\'long\'} - 1); }";
    }';
    eval 'sub MH_ALIGN {
        local($m, $len) = @_;
        eval "{ ($m)->defined &m_data && &m_data += (defined &MHLEN && &MHLEN - ($len)) &~ ($sizeof{\'long\'} - 1); }";
    }';
    eval 'sub M_LEADINGSPACE {
        local($m) = @_;
        eval "(($m)->defined &m_flags && &m_flags & defined &M_EXT && &M_EXT ? 0 : ($m)->defined &m_flags && &m_flags & defined &M_PKTHDR && &M_PKTHDR ? ($m)->defined &m_data && &m_data - ($m)->defined &m_pktdat && &m_pktdat : ($m)->defined &m_data && &m_data - ($m)->defined &m_dat && &m_dat)";
    }';
    eval 'sub M_TRAILINGSPACE {
        local($m) = @_;
        eval "(($m)->defined &m_flags && &m_flags & defined &M_EXT && &M_EXT ? ($m)->defined &m_ext && &m_ext.defined &ext_buf && &ext_buf + ($m)->defined &m_ext && &m_ext.defined &ext_size && &ext_size - (($m)->defined &m_data && &m_data + ($m)->defined &m_len && &m_len) : &($m)->defined &m_dat && &m_dat[defined &MLEN && &MLEN] - (($m)->defined &m_data && &m_data + ($m)->defined &m_len && &m_len))";
    }';
    eval 'sub M_PREPEND {
        local($m, $plen, $how) = @_;
        eval "{ defined &if && &if ( &M_LEADINGSPACE($m) >= ($plen)) { ($m)->defined &m_data && &m_data -= ($plen); ($m)->defined &m_len && &m_len += ($plen); } defined &else && &else ($m) =  &m_prepend(($m), ($plen), ($how)); defined &if && &if (($m) && ($m)->defined &m_flags && &m_flags & defined &M_PKTHDR && &M_PKTHDR) ($m)->defined &m_pkthdr && &m_pkthdr.defined &len && &len += ($plen); }";
    }';
    eval 'sub MCHTYPE {
        local($m, $t) = @_;
        eval "{  &MBUFLOCK(defined &mbstat && &mbstat.defined &m_mtypes && &m_mtypes[($m)->defined &m_type && &m_type]--; defined &mbstat && &mbstat.defined &m_mtypes && &m_mtypes[$t]++;) ($m)->defined &m_type && &m_type = $t;}";
    }';
    eval 'sub M_COPYALL {1000000000;}';
    eval 'sub m_copy {
        local($m, $o, $l) = @_;
        eval " &m_copym(($m), ($o), ($l), defined &M_DONTWAIT && &M_DONTWAIT)";
    }';
    if (defined &KERNEL) {
	if (defined &MBTYPES) {
	    if (defined &DATAKIT) {
	    }
	}
	require 'machine/spl.ph';
    }
}
1;
