if (!defined &_SYS_WAIT_H_) {
    eval 'sub _SYS_WAIT_H_ {1;}';
    if (defined &_POSIX_SOURCE) {
	eval 'sub _W_INT {
	    local($i) = @_;
	    eval "($i)";
	}';
    }
    else {
	eval 'sub _W_INT {
	    local($w) = @_;
	    eval "(*&($w))";
	}';
	eval 'sub WCOREFLAG {0200;}';
    }
    eval 'sub _WSTATUS {
        local($x) = @_;
        eval "( &_W_INT($x) & 0177)";
    }';
    eval 'sub _WSTOPPED {0177;}';
    eval 'sub WIFSTOPPED {
        local($x) = @_;
        eval "( &_WSTATUS($x) == defined &_WSTOPPED && &_WSTOPPED)";
    }';
    eval 'sub WSTOPSIG {
        local($x) = @_;
        eval "( &_W_INT($x) >> 8)";
    }';
    eval 'sub WIFSIGNALED {
        local($x) = @_;
        eval "( &_WSTATUS($x) != defined &_WSTOPPED && &_WSTOPPED &&  &_WSTATUS($x) != 0)";
    }';
    eval 'sub WTERMSIG {
        local($x) = @_;
        eval "( &_WSTATUS($x))";
    }';
    eval 'sub WIFEXITED {
        local($x) = @_;
        eval "( &_WSTATUS($x) == 0)";
    }';
    eval 'sub WEXITSTATUS {
        local($x) = @_;
        eval "( &_W_INT($x) >> 8)";
    }';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub WCOREDUMP {
	    local($x) = @_;
	    eval "( &_W_INT($x) & defined &WCOREFLAG && &WCOREFLAG)";
	}';
	eval 'sub W_EXITCODE {
	    local($ret, $sig) = @_;
	    eval "(($ret) << 8 | ($sig))";
	}';
	eval 'sub W_STOPCODE {
	    local($sig) = @_;
	    eval "(($sig) << 8 | defined &_WSTOPPED && &_WSTOPPED)";
	}';
    }
    eval 'sub WNOHANG {1;}';
    eval 'sub WUNTRACED {2;}';
    if (!defined &_POSIX_SOURCE) {
	eval 'sub WAIT_ANY {(-1);}';
	eval 'sub WAIT_MYPGRP {0;}';
	require 'machine/endian.ph';
	if ( defined &BYTE_ORDER && &BYTE_ORDER == defined &LITTLE_ENDIAN && &LITTLE_ENDIAN) {
	}
	if ( defined &BYTE_ORDER && &BYTE_ORDER == defined &BIG_ENDIAN && &BIG_ENDIAN) {
	}
	if ( defined &BYTE_ORDER && &BYTE_ORDER == defined &LITTLE_ENDIAN && &LITTLE_ENDIAN) {
	}
	if ( defined &BYTE_ORDER && &BYTE_ORDER == defined &BIG_ENDIAN && &BIG_ENDIAN) {
	}
	eval 'sub w_termsig {defined &w_T && &w_T.defined &w_Termsig && &w_Termsig;}';
	eval 'sub w_coredump {defined &w_T && &w_T.defined &w_Coredump && &w_Coredump;}';
	eval 'sub w_retcode {defined &w_T && &w_T.defined &w_Retcode && &w_Retcode;}';
	eval 'sub w_stopval {defined &w_S && &w_S.defined &w_Stopval && &w_Stopval;}';
	eval 'sub w_stopsig {defined &w_S && &w_S.defined &w_Stopsig && &w_Stopsig;}';
	eval 'sub WSTOPPED {defined &_WSTOPPED && &_WSTOPPED;}';
    }
    if (!defined &KERNEL) {
	require 'sys/types.ph';
	require 'sys/cdefs.ph';
	if (!defined &_POSIX_SOURCE) {
	}
    }
}
1;
